<?php
// Exit if accessed directly
if ( !defined('ABSPATH')) exit;

/* Simply static temporary fixes */
add_filter('ss_excluded_by_default', function( $excluded ) { $newarr = array_diff($excluded, array('feed'));	djv_write_log($newarr); return $newarr;});
add_filter('simply_static_fetch_urls_batch_size', function( $batch_size ) { return 50; /* default is 50.*/ });


/* --------------------- Functions for updating themes ------------------------------ */
function caporil_child_get_remote_update_from( $urlbase, $slug ) {
 $url = $urlbase . '/wp-content/uploads/jsons/' . $slug . '.json';
 $remote =  wp_remote_get( $url, array( 'timeout' => 10, 'headers' => array( 'Accept' => 'application/json' ) ) );
 if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && 200 == $remote['response']['code'] && ! empty( $remote['body'] ) ) {
  $remote['urlbase'] = $urlbase;
 }
 return $remote;
}
function caporil_child_get_remote_update_info( $slug ) {
 $remote = get_transient( 'djv_update_' . $slug );
 if (false == $remote || is_wp_error($remote) || !isset( $remote['response']['code'] ) || 200 !== $remote['response']['code'] || empty( $remote['body'] ) ) {
  $remote = caporil_child_get_remote_update_from( get_site_url( ), $slug );
  if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && 200 == $remote['response']['code'] && ! empty( $remote['body'] ) ) {
   set_transient( 'djv_update_' . $slug, $remote, 10 ); // Save for only 10 seconds here
  } else {
   $remote = caporil_child_get_remote_update_from( 'https://blog.tremlas.com', $slug );
   if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && 200 == $remote['response']['code'] && ! empty( $remote['body'] ) ) {
    set_transient( 'djv_update_' . $slug, $remote, 43200 ); // Save for 12 hours
   }
  }
 }
 if ( !is_wp_error( $remote ) && isset( $remote['response']['code'] ) && 200 == $remote['response']['code'] && ! empty( $remote['body'] ) ) {
  $body = json_decode( $remote['body'] );
  $info =array(
    'name'          => 'Caporil Child',
    'slug'          => $slug,
    'version'       => $body->version,
    'requires'      => $body->requires,
    'author'        => '<a href="' . $body->author_profile . '">' . $body->author . '</a>',
    'download_link' => $remote['urlbase'] . '/' . $body->download_url,
    'trunk'         => $remote['urlbase'] . '/' . $body->download_url,
    'last_updated'  => $body->last_updated,
    'sections'      => array(
      'description'  => implode( "\n", $body->sections->description ),
      'installation' => implode( "\n", $body->sections->installation ),
      'changelog'    => implode( "\n", $body->sections->changelog ),
    ),
    'homepage'      => $remote['urlbase'] . '/' . $body->homepage
  );
  return $info;
 }
 return false;
}

function caporil_child_check_for_update( $slug ) {
 $info = caporil_child_get_remote_update_info( $slug );
 if ( false == $info ) {
  return false;
 }
 if ( version_compare( '3.280.0', $info['version'], '<' ) && version_compare( $info['requires'], get_bloginfo( 'version' ), '<' ) ) {
  $update = array(
    'slug'          => $slug,
    'new_version'   => $info['version'],
    'url'           => $info['homepage'],
    'package'       => $info['download_link'],
    'icons'         => array(),
    'banners'       => array(),
    'banners_rtl'   => array(),
    'tested'        => '',
    'requires_php'  => '',
    'compatability' => new StdClass()
  );
  return $update;
 } else {
  return false;
 }
}

function caporil_child_pre_set_site_transient_update_themes( $transient ) {
 // Check for update
 $themeslug = 'caporilChild';
 $update = caporil_child_check_for_update( $themeslug );
 if ( $update ) {
  $transient->response[$themeslug] = $update;
 }
 return $transient;
}
add_filter( 'pre_set_site_transient_update_themes', 'caporil_child_pre_set_site_transient_update_themes' );

function caporil_child_theme_info( $result, $action, $args ) {
 $slug = 'caporilChild';
 if ( 'plugin_information' !== $action ) {
  return $result;
 }
 if ( $slug !== $args->slug) {
  return $result;
 }
 return caporil_child_get_remote_update_info( $slug );
}
add_filter( 'themes_api', 'caporil_child_theme_info', 10, 3 );

